import React from 'react';
import { DataType, Options, OnSubmit, ValidationPayload, ElementLike } from './types';
export default function useForm<Data extends DataType, Name extends keyof Data = keyof Data>({ mode, validationSchema, defaultValues, validationFields, nativeValidation, submitFocusError, validationSchemaOption, }?: Options<Data>): {
    register: {
        <Element_1 extends ElementLike<HTMLInputElement> = ElementLike<HTMLInputElement>>(validateRule: Partial<{
            required?: string | boolean | undefined;
            min?: string | number | {
                value: string | number;
                message: string;
            } | undefined;
            max?: string | number | {
                value: string | number;
                message: string;
            } | undefined;
            maxLength?: string | number | {
                value: string | number;
                message: string;
            } | undefined;
            minLength?: string | number | {
                value: string | number;
                message: string;
            } | undefined;
            pattern?: RegExp | {
                value: RegExp;
                message: string;
            } | undefined;
            validate?: import("./types").Validate | Record<string, import("./types").Validate> | {
                value: import("./types").Validate | Record<string, import("./types").Validate>;
                message: string;
            } | undefined;
        }>): (ref: Element_1 | null) => void;
        <Element_1 extends ElementLike<HTMLInputElement> = ElementLike<HTMLInputElement>>(input: Element_1, validationOptions?: Partial<{
            required?: string | boolean | undefined;
            min?: string | number | {
                value: string | number;
                message: string;
            } | undefined;
            max?: string | number | {
                value: string | number;
                message: string;
            } | undefined;
            maxLength?: string | number | {
                value: string | number;
                message: string;
            } | undefined;
            minLength?: string | number | {
                value: string | number;
                message: string;
            } | undefined;
            pattern?: RegExp | {
                value: RegExp;
                message: string;
            } | undefined;
            validate?: import("./types").Validate | Record<string, import("./types").Validate> | {
                value: import("./types").Validate | Record<string, import("./types").Validate>;
                message: string;
            } | undefined;
        }> | undefined): undefined;
    };
    unregister: {
        (name: string | Name): void;
        (names: (string | Name)[]): void;
    };
    handleSubmit: (callback: OnSubmit<Data>) => (e: React.SyntheticEvent<Element, Event>) => Promise<void>;
    watch: {
        (): Data;
        (field: string | Name, defaultValue?: string | undefined): any;
        (fields: (string | Name)[], defaultValues?: Partial<Data> | undefined): Partial<Data>;
    };
    reset: (values?: Record<string, any> | undefined) => void;
    clearError: {
        (): void;
        (name: Name): void;
        (names: Name[]): void;
    };
    setError: (name: Name, type: string, message?: string | undefined, ref?: any) => void;
    setValue: (name: Name, value: Data[Name], shouldValidate?: boolean) => void | Promise<boolean>;
    triggerValidation: (payload?: ValidationPayload<Name, Data[Name]> | ValidationPayload<Name, Data[Name]>[] | undefined) => Promise<boolean>;
    getValues: (payload?: {
        nest: boolean;
    } | undefined) => Data;
    errors: import("./types").ObjectErrorMessages<Data>;
    formState: {
        isValid: boolean;
        dirty: boolean;
        isSubmitted: boolean;
        submitCount: number;
        touched: Name[];
        isSubmitting: boolean;
    };
};
